package info.lotosummary.software;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;

public class GizeFrame extends JFrame {
    static final boolean IMPERFECT = false;
    static final boolean PERFECT = true;
    static final double N_2_31 = 2147483648.0; // 2^31 = 2147483648
    static final int CELL_FIELD_SIZE = 3;
    static final int COMMA_SIZE = 1;
    static final int CSV_COLUMN_COUNT = 7;
    static final int CSV_TAB = 2;
    static final int DRAW_ARRAY_SIZE = 12;
    static final int ERROR_CODE = 1;
    static final int FROM = 400;
    static final int HEADER_LINE_COUNT = 25;
    static final int LINE_COUNT = 300;
    static final int LINES = 2;
    static final int MAIN_HEIGHT = 521;
    static final int MAIN_WIDTH = 682;
    static final int MANAGE_TEXT_LINE_COUNT = 13;
    static final int MASK_COUNT = 8;
    static final int MATRIX_TAB = 1;
    static final int MERSENNE_TWISTER = 1;
    static final int NARROW_PANE = 263;
    static final int NOT_CONVERTED = -1;
    static final int OPTIONAL_TEXT_LINE_COUNT = 36;
    static final int PERIOD = 10;
    static final int ROW_COUNT = 24;
    static final int SHORT_PANE = 243;
    static final int STATUS_BAR_HEIGHT = 28;
    static final int TASK_BAR_HEIGHT = 28;
    static final int NON_SAMPLING_PERIOD = 1000;
    static final int TRIPLET_TAB = 0;
    static final int WIDE_PANE = 825;
    static final long KILOBYTES = 32L;
    static final String ANNUY_TEXT = "annuy.txt";
    static final String CELL1 = "01,02,03,04,05,";
    static final String CELL2 = "06,07,08,09,10,";
    static final String CELL3 = "11,12,13,14,15,";
    static final String CELL4 = "16,17,18,19,20,";
    static final String CELL6 = "21,22,23,24,25,";
    static final String CELL7 = "26,27,28,29,30,";
    static final String CELL8 = "31,32,33,34,35,";
    static final String CELL9 = "36,37,38,39,40,";
    static final String COMMA = ",";
    static final String COUNT_EIGHT = "Count Eight";
    static final String COUNT_FIVE = "Count Five ";
    static final String COUNT_FOUR = "Count Four ";
    static final String COUNT_ONE = "Count One  ";
    static final String COUNT_SIX = "Count Six  ";
    static final String COUNT_THREE = "Count Three";
    static final String COUNT_TWO = "Count Two  ";
    static final String DRAFO_CSV = "drafo.csv";
    static final String EMPTY = "";
    static final String ERROR_TEXT = "error.txt";
    static final String EXCLUDE_TEXT = "exclude.txt";
    static final String FALSE = "0";
    static final String FREE = "**";
    static final String GAP = " ";
    static final String GAP_CODE = "GAP";
    static final String GAP_SLASH = " /";
    static final String GAP_SLASH_SLASH = " //";
    static final String HEADER_DATA = "Data";
    static final String HEADER_WORD = "Word";
    static final String HYPHEN = "-";
    static final String MANAGE_TEXT = "manage.txt";
    static final String MANY_HYPHENS = "--------------------------------------"; // 38 hyphens
    static final String N_0TO9 = "0123456789";
    static final String NO_ERROR = "No error";
    static final String OPTIONAL_TEXT = "optional.txt";
    static final String REMOVE_ERROR_TEXT = "remove_e.txt";
    static final String RVOY = "rvoy.exe";
    static final String SEGMENT_TEXT = "segmen.txt";
    static final String TEXT_FILE = ".txt";
    static final String WHO = "who";
    static final String[] COLUMN_NAMES = {"Lines", "Bingo-5", "QP", "Date", "ID", "Res-number", "Name"};

    private BorderLayout borderLayout1 = new BorderLayout(); // contentPane
    private BorderLayout borderLayout2 = new BorderLayout(); // tripletTabPanel
    private BorderLayout borderLayout3 = new BorderLayout(); // tripletNorthPanel
    private BorderLayout borderLayout4 = new BorderLayout(); // matrixTabPanel
    private BorderLayout borderLayout5 = new BorderLayout(); // matrixNorthPanel
    private DefaultTableModel tableModel1;
    private FlowLayout flowLayout1 = new FlowLayout(); // matrixWestFlowPanel
    private FlowLayout flowLayout2 = new FlowLayout(); // matrixSouthFlowPanel
    private GridLayout gridLayout1 = new GridLayout(); // matrixNorthWestGridPanel
    private GridLayout gridLayout2 = new GridLayout(); // matrixNorthEastGridPanel
    private ImageIcon icon_of_numbered_cells = new ImageIcon("info/numbered_cells.gif");
    private ImageIcon icon01 = new ImageIcon("info/gize01.gif");
    private ImageIcon icon02 = new ImageIcon("info/gize02.gif");
    private ImageIcon icon03 = new ImageIcon("info/gize03.gif");
    private ImageIcon icon04 = new ImageIcon("info/gize04.gif");
    private ImageIcon icon05 = new ImageIcon("info/gize05.gif");
    private ImageIcon icon06 = new ImageIcon("info/gize06.gif");
    private ImageIcon icon07 = new ImageIcon("info/gize07.gif");
    private ImageIcon icon08 = new ImageIcon("info/gize08.gif");
    private ImageIcon icon09 = new ImageIcon("info/gize09.gif");
    private ImageIcon icon1_2_3 = new ImageIcon("info/annuy1_2_3d.gif");
    private ImageIcon icon1_4_7 = new ImageIcon("info/annuy1_4_7d.gif");
    private ImageIcon icon1_9 = new ImageIcon("info/annuy1_9d.gif");
    private ImageIcon icon10 = new ImageIcon("info/gize10.gif");
    private ImageIcon icon11 = new ImageIcon("info/gize11.gif");
    private ImageIcon icon12 = new ImageIcon("info/gize12.gif");
    private ImageIcon icon13 = new ImageIcon("info/gize13.gif");
    private ImageIcon icon14 = new ImageIcon("info/gize14.gif");
    private ImageIcon icon15 = new ImageIcon("info/gize15.gif");
    private ImageIcon icon16 = new ImageIcon("info/gize16.gif");
    private ImageIcon icon17 = new ImageIcon("info/gize17.gif");
    private ImageIcon icon18 = new ImageIcon("info/gize18.gif");
    private ImageIcon icon19 = new ImageIcon("info/gize19.gif");
    private ImageIcon icon2_8 = new ImageIcon("info/annuy2_8d.gif");
    private ImageIcon icon20 = new ImageIcon("info/gize20.gif");
    private ImageIcon icon21 = new ImageIcon("info/gize21.gif");
    private ImageIcon icon22 = new ImageIcon("info/gize22.gif");
    private ImageIcon icon23 = new ImageIcon("info/gize23.gif");
    private ImageIcon icon24 = new ImageIcon("info/gize24.gif");
    private ImageIcon icon25 = new ImageIcon("info/gize25.gif");
    private ImageIcon icon26 = new ImageIcon("info/gize26.gif");
    private ImageIcon icon27 = new ImageIcon("info/gize27.gif");
    private ImageIcon icon28 = new ImageIcon("info/gize28.gif");
    private ImageIcon icon29 = new ImageIcon("info/gize29.gif");
    private ImageIcon icon3_6_9 = new ImageIcon("info/annuy3_6_9d.gif");
    private ImageIcon icon3_7 = new ImageIcon("info/annuy3_7d.gif");
    private ImageIcon icon30 = new ImageIcon("info/gize30.gif");
    private ImageIcon icon31 = new ImageIcon("info/gize31.gif");
    private ImageIcon icon32 = new ImageIcon("info/gize32.gif");
    private ImageIcon icon33 = new ImageIcon("info/gize33.gif");
    private ImageIcon icon34 = new ImageIcon("info/gize34.gif");
    private ImageIcon icon35 = new ImageIcon("info/gize35.gif");
    private ImageIcon icon36 = new ImageIcon("info/gize36.gif");
    private ImageIcon icon37 = new ImageIcon("info/gize37.gif");
    private ImageIcon icon38 = new ImageIcon("info/gize38.gif");
    private ImageIcon icon39 = new ImageIcon("info/gize39.gif");
    private ImageIcon icon4_6 = new ImageIcon("info/annuy4_6d.gif");
    private ImageIcon icon40 = new ImageIcon("info/gize40.gif");
    private ImageIcon icon41 = new ImageIcon("info/gize41.gif");
    private ImageIcon icon7_8_9 = new ImageIcon("info/annuy7_8_9d.gif");
    private ImageIcon[] cell1 = {icon01, icon02, icon03, icon04, icon05};
    private ImageIcon[] cell2 = {icon06, icon07, icon08, icon09, icon10};
    private ImageIcon[] cell3 = {icon11, icon12, icon13, icon14, icon15};
    private ImageIcon[] cell4 = {icon16, icon17, icon18, icon19, icon20};
    private ImageIcon[] cell6 = {icon21, icon22, icon23, icon24, icon25};
    private ImageIcon[] cell7 = {icon26, icon27, icon28, icon29, icon30};
    private ImageIcon[] cell8 = {icon31, icon32, icon33, icon34, icon35};
    private ImageIcon[] cell9 = {icon36, icon37, icon38, icon39, icon40};
    private ImageIcon[] flowLine = new ImageIcon[MASK_COUNT];
    private ImageIcon[] imageList = {icon1_2_3, icon7_8_9, icon1_4_7, icon3_6_9, icon4_6, icon2_8, icon1_9, icon3_7};
    private JButton countButton = new JButton();
    private JComboBox<String> countComboBox = new JComboBox<String>();
//    private JComboBox countComboBox = new JComboBox();
    private JLabel contentPaneEastLabel = new JLabel();
    private JLabel contentPaneNorthLabel = new JLabel();
    private JLabel contentPaneWestLabel = new JLabel();
    private JLabel iconCenterLabel1, iconCenterLabel2, iconCenterLabel3, iconCenterLabel4, iconCenterLabel5, iconCenterLabel6, iconCenterLabel7, iconCenterLabel8, iconCenterLabel9, iconWestLabel1, iconWestLabel2, iconWestLabel3, iconWestLabel4, iconWestLabel5, iconWestLabel6, iconWestLabel7, iconWestLabel8, iconWestLabel9;
    private JLabel matrixCenterLabel = new JLabel();
    private JLabel matrixEastLabel = new JLabel();
    private JLabel matrixNorthCenterLabel;
    private JLabel matrixNorthNorthLabel = new JLabel();
    private JLabel matrixNorthSouthLabel = new JLabel();
    private JLabel statusBar = new JLabel();
    private JLabel tripletNorthLabel = new JLabel();
    private JLabel[] matrixSouthFlowCenterLabel = new JLabel[MASK_COUNT];
    private JLabel[] matrixWestFlowCenterLabel = new JLabel[MASK_COUNT];
    private JMenu jMenuFile = new JMenu();
    private JMenu jMenuFileCount = new JMenu();
    private JMenu jMenuHelp = new JMenu();
    private JMenu jMenuWindow = new JMenu();
    private JMenuBar jMenuBar1 = new JMenuBar();
    private JMenuItem jMenuFileAwakening = new JMenuItem();
    private JMenuItem jMenuFileClean = new JMenuItem();
    private JMenuItem jMenuFileCountEightLines = new JMenuItem();
    private JMenuItem jMenuFileCountFiveLines = new JMenuItem();
    private JMenuItem jMenuFileCountFourLines = new JMenuItem();
    private JMenuItem jMenuFileCountOneLine = new JMenuItem();
    private JMenuItem jMenuFileCountSixLines = new JMenuItem();
    private JMenuItem jMenuFileCountThreeLines = new JMenuItem();
    private JMenuItem jMenuFileCountTwoLines = new JMenuItem();
    private JMenuItem jMenuFileCSV = new JMenuItem();
    private JMenuItem jMenuFileExit = new JMenuItem();
    private JMenuItem jMenuFileManage = new JMenuItem();
    private JMenuItem jMenuFileMatrix = new JMenuItem();
    private JMenuItem jMenuFileOptional = new JMenuItem();
    private JMenuItem jMenuFilePreedit = new JMenuItem();
    private JMenuItem jMenuHelpAbout = new JMenuItem();
    private JMenuItem jMenuWindowCenter = new JMenuItem();
    private JMenuItem jMenuWindowCorner = new JMenuItem();
    private JMenuItem jMenuWindowCSV = new JMenuItem();
    private JMenuItem jMenuWindowDiagonal = new JMenuItem();
    private JMenuItem jMenuWindowHeight = new JMenuItem();
    private JMenuItem jMenuWindowMinimize = new JMenuItem();
    private JMenuItem jMenuWindowNarrow = new JMenuItem();
    private JMenuItem jMenuWindowRight = new JMenuItem();
    private JMenuItem jMenuWindowSmall = new JMenuItem();
    private JMenuItem jMenuWindowStandard = new JMenuItem();
    private JMenuItem jMenuWindowUnder = new JMenuItem();
    private JMenuItem jMenuWindowWidth = new JMenuItem();
    private JPanel contentPane;
    private JPanel matrixNorthEastGridPanel = new JPanel();
    private JPanel matrixNorthPanel = new JPanel();
    private JPanel matrixNorthWestGridPanel = new JPanel();
    private JPanel matrixSouthFlowPanel = new JPanel();
    private JPanel matrixTabPanel = new JPanel();
    private JPanel matrixWestFlowPanel = new JPanel();
    private JPanel tripletNorthPanel = new JPanel();
    private JPanel tripletTabPanel = new JPanel();
    private JScrollPane jScrollPane1 = new JScrollPane(); // CSV tab
    private JTabbedPane jTabbedPane1 = new JTabbedPane();
    private JTextArea tripletSouthTextArea = new JTextArea();
    private JTextField tripletEastTextField = new JTextField();

    boolean cell_5, csv, firstLine, narrowPane, noSplitting, onlyTwo, preedit, quit, serialNumber, shortPane, ticketForm, toGize, whoText, widePane;
    double versionNumber;
    Drafo dr;
    ExcludeText et;
    GizeMask gm;
    int imageCount, itemCount, lines, main_height, main_width, main_x, main_y, NEW_LINE_LENGTH, rowCount, standard_main_x, standard_main_y, tabSelected, whichCorner, written;
    String DOUBLE_SPACE, fileName, error, FULL_PATH_NAME, list_of_items, name_of_CSV, NEW_LINE, statusBarText, secondLine, whoTextLine1;
    String textFieldLine = MANY_HYPHENS;
    String tripletNorthLabelText = HYPHEN;
    String[] draw = {"", "", "", "", "", "", "", "", "", "", "", ""};
    String[] m = {
             "", // m[0], FULL_PATH_NAME includes MANAGE_TEXT.
      "who.txt", // m[1], fileName
  "exclude.txt", // m[2], list_of_items
            "2", // m[3], lines
            "0", // m[4], cell_5
            "1", // m[5], firstLine
            "0", // m[6], noSplitting
            "1", // m[7], preedit
         "5000", // m[8], rowCount
            "1", // m[9], serialNumber
            "0", // m[10], ticketForm
            "0", // m[11], whoText
            "1", // m[12], toGize
            "0"  // m[13], whichCorner
        };

    String[] optional;
    String[] table;
    StringBuffer buffer;
    java.util.Timer timer;
    TimerTask task;
    Triplet tr;

    private boolean createAnnuyText() {
        int q = FULL_PATH_NAME.indexOf(MANAGE_TEXT);
        String pathName = FULL_PATH_NAME.substring(0, q) + ANNUY_TEXT;
        long kilo = KILOBYTES;
        long seed = 0L;
        int from = FROM; // idling
        int lineCount = LINE_COUNT;
        int prng = MERSENNE_TWISTER; // MT
        boolean cell_5 = false;
        boolean produce_annuy_text = true;

        RandomNumber r = new RandomNumber(kilo, seed, from, lineCount, prng, cell_5, produce_annuy_text);
        return r.createAnnuyText(pathName);
    }

    private boolean createDrafoCsv() {
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(DRAFO_CSV) );
            file.write("&#160;, ,"); file.newLine();
            file.write("&nbsp;, ,"); file.newLine();
            file.write("a,A,"); file.newLine();
            file.write("l,L,"); file.newLine();
            file.write("p,P,"); file.newLine();
            file.write("q,Q,"); file.newLine();
            file.write("\\,, ,"); file.newLine();
            file.write("., ,"); file.newLine();
            file.write("      , ,"); file.newLine();
            file.write("     , ,"); file.newLine();
            file.write("    , ,"); file.newLine();
            file.write("   , ,"); file.newLine();
            file.write("  , ,"); file.newLine();
            file.write(" 1 , 01 ,"); file.newLine();
            file.write(" 2 , 02 ,"); file.newLine();
            file.write(" 3 , 03 ,"); file.newLine();
            file.write(" 4 , 04 ,"); file.newLine();
            file.write(" 5 , 05 ,"); file.newLine();
            file.write(" 6 , 06 ,"); file.newLine();
            file.write(" 7 , 07 ,"); file.newLine();
            file.write(" 8 , 08 ,"); file.newLine();
            file.write(" 9 , 09 ,"); file.newLine();
            file.write("ALLQP,ALL QP,"); file.newLine();
            file.write("|,/,"); file.newLine();
            file.close();
            return true;
        } catch(Exception e43) {
            error = "Exception e43: " + DRAFO_CSV;
            return false;
        }

    }

    private boolean createErrorText(String messages) {
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(ERROR_TEXT) );
            file.write(messages); file.newLine();
            file.close();
            return true;
        } catch(Exception e44) {
            error = "Exception e44: " + ERROR_TEXT;
            return false;
        }

    }

    private boolean createExcludeText() {
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(EXCLUDE_TEXT) );
            file.write("ʂ"); file.newLine(); // Shift_JIS
            file.write(" ID:"); file.newLine();
            file.close();
            return true;
        } catch(Exception e45) {
            error = "Exception e45: " + EXCLUDE_TEXT;
            return false;
        }

    }

    private boolean CSVdialog() {
        TableCsv tc = new TableCsv(rowCount, cell_5, serialNumber, whoText);
        if( tc.run(fileName) ) {
            name_of_CSV = tc.saved();
            String[] table = tc.csvList();
            statusBarMessage(name_of_CSV);

            GizeFrame_CsvBox dlg = new GizeFrame_CsvBox(this);
            Dimension dlgSize = dlg.getPreferredSize();
            Dimension frmSize = getSize();
            Point loc = getLocation();
            dlg.setLocation( loc.x + frmSize.width/2 - dlgSize.width/2, loc.y + frmSize.height/2 - dlgSize.height/2 );
            dlg.setting(table, name_of_CSV, rowCount);
            dlg.setModal(true);
            dlg.pack();
            dlg.setVisible(true);
            return true;
        } else {
            error = "tc.run( " + fileName + " )";
            createErrorText(error);
            return false;
        }

    }

    private boolean editCountLines() {
        csv = false;
        quit = false;

        EditCount ec = new EditCount();
        ec.setting(this, FULL_PATH_NAME, fileName, list_of_items, lines, cell_5, csv, firstLine, noSplitting, preedit, quit, serialNumber, ticketForm, whoText);
        if( ec.editCount() ) {
            String textName = ec.saved();
            statusBarMessage(textName);
            return true;
        } else {
            error = ec.inquiry();
            createErrorText(error);
            return false;
        }

    }

    private boolean optionalAdding() {
        Optional p = new Optional(FULL_PATH_NAME, OPTIONAL_TEXT);
        optional = p.readOptionalText();
        if( EMPTY.equals(optional[0]) ) {
            error = "EMPTY.equals(optional[0]): " + OPTIONAL_TEXT;
            createErrorText(error);
            return false;
        } else {
            statusBarMessage(OPTIONAL_TEXT);

            for(int i = 0; i < OPTIONAL_TEXT_LINE_COUNT; ++i) {
                if(optional[i] == null) {
                    break;
                }

                countComboBox.addItem(optional[i]);
//                countComboBox.addItem( makeObj(optional[i]) );
            }

            int itemCount = countComboBox.getItemCount();
            countComboBox.setSelectedIndex( itemCount - 1 );
            return true;
        }

    }

    private boolean preediting() {
        EditCount ec = new EditCount();
        ec.setting(this, FULL_PATH_NAME, fileName, list_of_items, lines, cell_5, csv, firstLine, noSplitting, preedit, quit, serialNumber, ticketForm, whoText);
        if( ec.preediting() ) {
            String textName = ec.saved();
            statusBarMessage(textName);
            return true;
        } else {
            error = ec.inquiry();
            createErrorText(error);
            return false;
        }

    }

    private boolean readManageText() {
        m[0] = FULL_PATH_NAME;

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(FULL_PATH_NAME) );
            for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1) {
                m[line] = buffered.readLine();
                if(m[line] == null) {
                    break;
                }

            }

            buffered.close();
            stringArrayToValues();
            return true;
        } catch(IOException e67) {
            error = "IOException e67: " + FULL_PATH_NAME;
            createErrorText(error);
            return false;
        }

    }

    private String segmentalize(String newLine1) {
        Characterizable lineType = new Consecutive(EMPTY);
        String s;
        StringBuffer os = new StringBuffer();
        os.append(newLine1);
        os.append(DOUBLE_SPACE);

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(SEGMENT_TEXT) );

            s = buffered.readLine();
            if(s == null) {
                error = "buffered.readLine(): s == null";
                return EMPTY;
            }

            lineType = new Consecutive(s);
            int r = lineType.dateLine();
            if(r <= 0) {
                error = "lineType.dateLine(): r <= 0";
                return EMPTY;
            }

            os.append(s);
            os.append(NEW_LINE);
            buffered.close();
        } catch(IOException e51) {
            error = "IOException e51: " + SEGMENT_TEXT;
            return EMPTY;
        }

        try {
            BufferedReader text = new BufferedReader( new FileReader(ANNUY_TEXT) );

            int line = 0;
            for(;;) {
                s = text.readLine();
                if(s == null) {
                    break;
                }

                os.append(s);
                os.append(NEW_LINE);
                line += 1;
                if(line == PERIOD) {
                    s = lineType.rebuild();
                    os.append(NEW_LINE);
                    os.append(s);
                    os.append(NEW_LINE);
                    line = 0;
                }

            }

            text.close();
            error = lineType.pileOfErrorMessages();
            if(! NO_ERROR.equals(error) ) {
                return EMPTY;
            }

        } catch(IOException e54) {
            error = "IOException e54: " + ANNUY_TEXT;
            return EMPTY;
        }

        String buffer = os.toString();
        TimeName wt = new TimeName(WHO, TEXT_FILE);
        String timeNameText = wt.temporaryName(serialNumber);
        statusBarMessage(timeNameText);

        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(timeNameText) );
            file.write(buffer);
            file.close();
            return timeNameText;
        } catch(IOException e4) {
            error = "IOException e4: " + timeNameText;
            return EMPTY;
        }

    }

    private boolean testDrafoCsv() {
        try {
            BufferedReader buffered = new BufferedReader( new FileReader(DRAFO_CSV) );
            buffered.close();
            return true;
        } catch(IOException e36) {
            error = "IOException e36: " + DRAFO_CSV;
            createErrorText(error);

            createDrafoCsv();
            return false;
        }

    }

    private ImageIcon icon_of_cell_1(String[] a) {
        ImageIcon icon = icon41;
        int q = CELL1.indexOf(a[1]);
        if(q >= 0) {
            icon = cell1[ q/CELL_FIELD_SIZE ];
        }

        return icon;
    }

    private ImageIcon icon_of_cell_2(String[] a) {
        ImageIcon icon = icon41;
        int q = CELL2.indexOf(a[2]);
        if(q >= 0) {
            icon = cell2[ q/CELL_FIELD_SIZE ];
        }

        return icon;
    }

    private ImageIcon icon_of_cell_3(String[] a) {
        ImageIcon icon = icon41;
        int q = CELL3.indexOf(a[3]);
        if(q >= 0) {
            icon = cell3[ q/CELL_FIELD_SIZE ];
        }

        return icon;
    }

    private ImageIcon icon_of_cell_4(String[] a) {
        ImageIcon icon = icon41;
        int q = CELL4.indexOf(a[4]);
        if(q >= 0) {
            icon = cell4[ q/CELL_FIELD_SIZE ];
        }

        return icon;
    }

    private ImageIcon icon_of_cell_6(String[] a) {
        ImageIcon icon = icon41;
        int q = CELL6.indexOf(a[6]);
        if(q >= 0) {
            icon = cell6[ q/CELL_FIELD_SIZE ];
        }

        return icon;
    }

    private ImageIcon icon_of_cell_7(String[] a) {
        ImageIcon icon = icon41;
        int q = CELL7.indexOf(a[7]);
        if(q >= 0) {
            icon = cell7[ q/CELL_FIELD_SIZE ];
        }

        return icon;
    }

    private ImageIcon icon_of_cell_8(String[] a) {
        ImageIcon icon = icon41;
        int q = CELL8.indexOf(a[8]);
        if(q >= 0) {
            icon = cell8[ q/CELL_FIELD_SIZE ];
        }

        return icon;
    }

    private ImageIcon icon_of_cell_9(String[] a) {
        ImageIcon icon = icon41;
        int q = CELL9.indexOf(a[9]);
        if(q >= 0) {
            icon = cell9[ q/CELL_FIELD_SIZE ];
        }

        return icon;
    }

    private int sequenceOfNumbers(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                count += 1;
                continue;
            } else {
                break;
            }

        }

        return count;
    }

    private int sequence_of_non_numbers(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                break;
            } else {
                count += 1;
                continue;
            }

        }

        return count;
    }

    private int stringToInteger(String s) {
        int result;

        try {
            result = Integer.parseInt(s);
            return result;
        } catch(NumberFormatException e53) {
            error = "NumberFormatException e53";
            return NOT_CONVERTED;
        }

    }

    private Object makeObj(final String item)  {
        return new Object() { public String toString() { return item; } };
    }

    private String drawLine() {
        StringBuffer os = new StringBuffer();
        os.append(draw[1]);
        os.append(GAP);
        os.append(draw[2]);
        os.append(GAP);
        os.append(draw[3]);
        os.append(GAP_SLASH);
        os.append(draw[4]);
        os.append(GAP);
        os.append(draw[6]);
        os.append(GAP_SLASH);
        os.append(draw[7]);
        os.append(GAP);
        os.append(draw[8]);
        os.append(GAP);
        os.append(draw[9]);
        os.append(GAP_SLASH_SLASH);
        String s = os.toString();

        return s;
    }

    private String header(String name) {
        try {
            BufferedReader buffered = new BufferedReader( new FileReader(name) );
            String s;
            StringBuffer os = new StringBuffer();
            for(int line = 1; line <= HEADER_LINE_COUNT; line += 1 ) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                os.append(s);
                os.append(NEW_LINE);
            }

            buffered.close();
            s = os.toString();
            return s;
        } catch(IOException e12) {
            error = "IOException e12: " + name;
            createErrorText(error);
            return EMPTY;
        }

    }

    private String selectingAsDraw(int from) {
// Time is used as seed.
        Calendar now = Calendar.getInstance();
        int year = now.get(Calendar.YEAR);
        int month = now.get(Calendar.MONTH);
        int day = now.get(Calendar.DATE);
        int hour = now.get(Calendar.HOUR);
        int minute = now.get(Calendar.MINUTE);
        int second = now.get(Calendar.SECOND);
        int add = minute * 60 + hour * 60 * 60;
        int year_month_day_43 = (year + month + day) * 43;
        second += add;
        second += year_month_day_43;

        long seed = (long)second;
        PRNG prn = new MT(seed);

// idling
        for(int i = 0; i < from; ++i) { 
            prn.nextRandom();
        }

// Selecting Line-N from ANNUY_TEXT lines
        int interval_0 = 1;
        int interval_1 = LINE_COUNT;
        double difference = (double)( interval_1 - interval_0 + 1 );
        double range = difference/4294967296.0;
        double g = (double)prn.nextRandom();
        g += N_2_31; // 0 to 4294967295

        int plus = (int)Math.floor( range * g );
        int N = interval_0 + plus; // Line-N

        try {
            BufferedReader text = new BufferedReader( new FileReader(ANNUY_TEXT) );
            String s = EMPTY;
            for(int line = 1; line < LINE_COUNT; line += 1 ) {
                s = text.readLine();
                if(s == null) {
                    break;
                }

                if(line == N) {
                    break;
                }

            }

            text.close();
            return s;
        } catch(IOException e55) {
            error = "IOException e55: " + ANNUY_TEXT;
            return EMPTY;
        }

    }

    private String similarBall(String s) {
        String u = EMPTY;
// cell-6
        if( s.equals("21") ) {
            u = "22";
        } else if( s.equals("22") ) {
            u = "23";
        } else if( s.equals("23") ) {
            u = "24";
        } else if( s.equals("24") ) {
            u = "25";
        } else if( s.equals("25") ) {
            u = "21";

// cell-7
        } else if( s.equals("26") ) {
            u = "27";
        } else if( s.equals("27") ) {
            u = "28";
        } else if( s.equals("28") ) {
            u = "29";
        } else if( s.equals("29") ) {
            u = "30";
        } else if( s.equals("30") ) {
            u = "26";
        }

        return u;
    }

    private String[] dividing(String line) {
        String[] a = {"", "", "", "", "", "", "", "", "", "", "", ""};
        int from = 0;
        int n, u;
        int p = 0;

        for(int i = 1; i < DRAW_ARRAY_SIZE; ++i) {
            if(i == 5) {
                a[5] = FREE;
                continue;
            }

            n = sequenceOfNumbers(line, p);
            from = p;
            p += n;

            u = sequence_of_non_numbers(line, p);
            p += u;

            a[i] = line.substring(from, from + n );
        }

        return a;
    }

    private String[] septet(String row) {
// Dividing a CSV row into seven items: Lines, Bingo-5, QP, Date, ID, Res-number, and Name.
       int q;
       String tail = new String(row);
       String[] c = new String[CSV_COLUMN_COUNT];
       String[] empty = {"", "", "", "", "", "", ""};

       for(int i = 0; i < CSV_COLUMN_COUNT; ++i) {
           q = tail.indexOf(COMMA);
           if(q >= 0) {
               c[i] = tail.substring(0, q);
               q += COMMA_SIZE;
               tail = tail.substring(q);
           } else {
               return empty;
           }

        }

        return c;
    }

    private void centering() {
        whichCorner = 0;

        GraphicsConfiguration gc = this.getGraphicsConfiguration();
        Rectangle bounds = gc.getBounds();
        main_height = this.getHeight();
        main_width = this.getWidth();

        main_x = bounds.width/2 - main_width/2;
        main_y = bounds.height/2 - main_height/2;
        this.setLocation( bounds.x + main_x, bounds.y + main_y );

        standard_main_x = main_x;
        standard_main_y = main_y;
    }

    private void cornerHandler() {
        whichCorner = 1;

        GraphicsConfiguration gc = this.getGraphicsConfiguration();
        Rectangle bounds = gc.getBounds();
        main_height = this.getHeight();
        main_width = this.getWidth();

        main_x = 0;
        main_y = 0;
        this.setLocation( bounds.x + main_x, bounds.y + main_y );
    }

    private void diagonalHandler() {
        whichCorner = 3;

        GraphicsConfiguration gc = this.getGraphicsConfiguration();
        Rectangle bounds = gc.getBounds();
        main_height = this.getHeight();
        main_width = this.getWidth();

        main_x = bounds.width - main_width;
        main_y = bounds.height - main_height - TASK_BAR_HEIGHT;
        this.setLocation( bounds.x + main_x, bounds.y + main_y );
    }

    private void jbInit() throws Exception  {
        setIconImage( Toolkit.getDefaultToolkit().createImage( GizeFrame.class.getResource("gize71.gif") ) );
        contentPane = (JPanel) this.getContentPane();
        contentPane.setLayout(borderLayout1);

// x, y, width, height
        narrowPane = false;
        shortPane = false;
        widePane = false;
        main_width = MAIN_WIDTH;
        main_height = MAIN_HEIGHT;
        this.setSize( new Dimension(main_width, main_height) );
        GraphicsConfiguration gc = this.getGraphicsConfiguration();
        Rectangle bounds = gc.getBounds();

        switch(whichCorner) {
        case 1:
            main_x = 0;
            main_y = 0;
            break;
        case 2:
            main_x = bounds.width - main_width;
            main_y = 0;
            break;
        case 3:
            main_x = bounds.width - main_width;
            main_y = bounds.height - main_height - TASK_BAR_HEIGHT;
            break;
        case 4:
            main_x = 0;
            main_y = bounds.height - main_height - TASK_BAR_HEIGHT;
            break;
        default:
            main_x = bounds.width/2 - main_width/2;
            main_y = bounds.height/2 - main_height/2;
            break;
        }

        this.setLocation( bounds.x + main_x, bounds.y + main_y );

        this.setTitle("Gize");
        this.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(MouseEvent e) {
                this_mouseMoved(e);
            }
        });
        statusBarMessage(name_of_CSV);
        statusBar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                statusBar_mouseClicked(e);
            }
        });

        jMenuFile.setText("File");
        jMenuFile.setMnemonic('F');
        jMenuFileAwakening.setText("Awakening");
        jMenuFileAwakening.setMnemonic('K');
        jMenuFileAwakening.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileAwakening_actionPerformed(e);
            }
        });
        jMenuFileClean.setText("Clean");
        jMenuFileClean.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileClean_actionPerformed(e);
            }
        });
        jMenuFileCount.setText("Count");
        jMenuFileCount.setMnemonic('C');
        jMenuFileCountOneLine.setText("One");
        jMenuFileCountOneLine.setMnemonic('O');
        jMenuFileCountOneLine.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileCountOneLine_actionPerformed(e);
            }
        });
        jMenuFileCountTwoLines.setText("Two");
        jMenuFileCountTwoLines.setMnemonic('T');
        jMenuFileCountTwoLines.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileCountTwoLines_actionPerformed(e);
            }
        });
        jMenuFileCountThreeLines.setText("Three");
        jMenuFileCountThreeLines.setMnemonic('R');
        jMenuFileCountThreeLines.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileCountThreeLines_actionPerformed(e);
            }
        });
        jMenuFileCountFourLines.setText("Four");
        jMenuFileCountFourLines.setMnemonic('U');
        jMenuFileCountFourLines.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileCountFourLines_actionPerformed(e);
            }
        });
        jMenuFileCountFiveLines.setText("Five");
        jMenuFileCountFiveLines.setMnemonic('I');
        jMenuFileCountFiveLines.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileCountFiveLines_actionPerformed(e);
            }
        });
        jMenuFileCountSixLines.setText("Six");
        jMenuFileCountSixLines.setMnemonic('S');
        jMenuFileCountSixLines.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileCountSixLines_actionPerformed(e);
            }
        });
        jMenuFileCountEightLines.setText("Eight");
        jMenuFileCountEightLines.setMnemonic('E');
        jMenuFileCountEightLines.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileCountEightLines_actionPerformed(e);
            }
        });
        jMenuFileCSV.setText("CSV");
        jMenuFileCSV.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileCSV_actionPerformed(e);
            }
        });
        jMenuFileExit.setText("Exit");
        jMenuFileExit.setMnemonic('X');
        jMenuFileExit.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileExit_actionPerformed(e);
            }
        });
        jMenuFileManage.setText("Manage");
        jMenuFileManage.setMnemonic('M');
        jMenuFileManage.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileManage_actionPerformed(e);
            }
        });
        jMenuFileMatrix.setText("Matrix");
        jMenuFileMatrix.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileMatrix_actionPerformed(e);
            }
        });
        jMenuFileOptional.setText("Optional");
        jMenuFileOptional.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileOptional_actionPerformed(e);
            }
        });
        jMenuFilePreedit.setText("Preedit");
        jMenuFilePreedit.setMnemonic('P');
        jMenuFilePreedit.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFilePreedit_actionPerformed(e);
            }
        });
        jMenuWindow.setText("Window");
        jMenuWindow.setMnemonic('W');
        jMenuWindowCenter.setText("Center");
        jMenuWindowCenter.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuWindowCenter_actionPerformed(e);
            }
        });
        jMenuWindowCorner.setText("Corner");
        jMenuWindowCorner.setMnemonic('N');
        jMenuWindowCorner.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuWindowCorner_actionPerformed(e);
            }
        });
        jMenuWindowCSV.setText("CSV");
        jMenuWindowCSV.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuWindowCSV_actionPerformed(e);
            }
        });
        jMenuWindowDiagonal.setText("Diagonal");
        jMenuWindowDiagonal.setMnemonic('D');
        jMenuWindowDiagonal.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuWindowDiagonal_actionPerformed(e);
            }
        });
        jMenuWindowHeight.setText("Height");
        jMenuWindowHeight.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuWindowHeight_actionPerformed(e);
            }
        });
        jMenuWindowMinimize.setText("Minimize");
        jMenuWindowMinimize.setMnemonic('Z');
        jMenuWindowMinimize.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuWindowMinimize_actionPerformed(e);
            }
        });
        jMenuWindowNarrow.setText("Narrow");
        jMenuWindowNarrow.setMnemonic('A');
        jMenuWindowNarrow.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuWindowNarrow_actionPerformed(e);
            }
        });
        jMenuWindowRight.setText("Right");
        jMenuWindowRight.setMnemonic('G');
        jMenuWindowRight.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuWindowRight_actionPerformed(e);
            }
        });
        jMenuWindowSmall.setText("Small");
        jMenuWindowSmall.setMnemonic('L');
        jMenuWindowSmall.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuWindowSmall_actionPerformed(e);
            }
        });
        jMenuWindowStandard.setText("Standard");
        jMenuWindowStandard.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuWindowStandard_actionPerformed(e);
            }
        });
        jMenuWindowUnder.setText("Under");
        jMenuWindowUnder.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuWindowUnder_actionPerformed(e);
            }
        });
        jMenuWindowWidth.setText("Width");
        jMenuWindowWidth.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuWindowWidth_actionPerformed(e);
            }
        });
        jMenuHelp.setText("Help");
        jMenuHelp.setMnemonic('H');
        jMenuHelpAbout.setText("Version");
        jMenuHelpAbout.setMnemonic('V');
        jMenuHelpAbout.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuHelpAbout_actionPerformed(e);
            }
        });
        contentPaneNorthLabel.setForeground(SystemColor.inactiveCaptionText);
        contentPaneNorthLabel.setText(" ");
        contentPaneWestLabel.setForeground(SystemColor.inactiveCaptionText);
        contentPaneWestLabel.setText(" ");
        contentPaneEastLabel.setForeground(SystemColor.inactiveCaptionText);
        contentPaneEastLabel.setText(" ");
        matrixNorthSouthLabel.setForeground(SystemColor.inactiveCaptionText);
        matrixNorthSouthLabel.setText(" ");
        jScrollPane1.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(MouseEvent e) {
                jScrollPane1_mouseMoved(e);
            }
        });
        jTabbedPane1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                jTabbedPane1_mouseClicked(e);
            }
        });
        jMenuFileCount.add(jMenuFileCountOneLine);
        jMenuFileCount.add(jMenuFileCountTwoLines);
        jMenuFileCount.add(jMenuFileCountThreeLines);
        jMenuFileCount.add(jMenuFileCountFourLines);
        jMenuFileCount.add(jMenuFileCountFiveLines);
        jMenuFileCount.add(jMenuFileCountSixLines);
        jMenuFileCount.addSeparator();
        jMenuFileCount.add(jMenuFileCountEightLines);
        jMenuFile.add(jMenuFileAwakening);
        jMenuFile.add(jMenuFileClean);
        jMenuFile.add(jMenuFileCount);
        jMenuFile.add(jMenuFileCSV);
        jMenuFile.add(jMenuFileExit);
        jMenuFile.add(jMenuFileManage);
        jMenuFile.add(jMenuFileMatrix);
        jMenuFile.add(jMenuFileOptional);
        jMenuFile.add(jMenuFilePreedit);

        jMenuWindow.add(jMenuWindowCenter);
        jMenuWindow.add(jMenuWindowCorner);
        jMenuWindow.add(jMenuWindowCSV);
        jMenuWindow.add(jMenuWindowDiagonal);
        jMenuWindow.add(jMenuWindowHeight);
        jMenuWindow.add(jMenuWindowMinimize);
        jMenuWindow.add(jMenuWindowNarrow);
        jMenuWindow.add(jMenuWindowRight);
        jMenuWindow.add(jMenuWindowSmall);
        jMenuWindow.add(jMenuWindowStandard);
        jMenuWindow.add(jMenuWindowUnder);
        jMenuWindow.add(jMenuWindowWidth);
        jMenuHelp.add(jMenuHelpAbout);
        jMenuBar1.add(jMenuFile);
        jMenuBar1.add(jMenuWindow);
        jMenuBar1.add(jMenuHelp);
        this.setJMenuBar(jMenuBar1);

        contentPane.add(contentPaneNorthLabel, BorderLayout.NORTH);
        contentPane.add(contentPaneWestLabel, BorderLayout.WEST);
        contentPane.add(contentPaneEastLabel, BorderLayout.EAST);
        contentPane.add(statusBar, BorderLayout.SOUTH); // private JLabel statusBar = new JLabel();
        contentPane.add(jTabbedPane1, BorderLayout.CENTER);
        tripletTabPanel.setLayout(borderLayout2);
        tripletNorthPanel.setLayout(borderLayout3);
        matrixTabPanel.setLayout(borderLayout4);
        matrixNorthPanel.setLayout(borderLayout5);
        matrixNorthCenterLabel = new JLabel(icon_of_numbered_cells);
        matrixSouthFlowPanel.setLayout(flowLayout2);
        matrixWestFlowPanel.setLayout(flowLayout1);

        matrixNorthWestGridPanel.setLayout(gridLayout1);
        gridLayout1.setColumns(3);
        gridLayout1.setRows(3);
        iconWestLabel1 = new JLabel( icon_of_cell_1(draw) );
        iconWestLabel2 = new JLabel( icon_of_cell_2(draw) );
        iconWestLabel3 = new JLabel( icon_of_cell_3(draw) );
        iconWestLabel4 = new JLabel( icon_of_cell_4(draw) );
        iconWestLabel5 = new JLabel(icon41);
        iconWestLabel6 = new JLabel( icon_of_cell_6(draw) );
        iconWestLabel7 = new JLabel( icon_of_cell_7(draw) );
        iconWestLabel8 = new JLabel( icon_of_cell_8(draw) );
        iconWestLabel9 = new JLabel( icon_of_cell_9(draw) );
        matrixNorthWestGridPanel.add(iconWestLabel1, null);
        matrixNorthWestGridPanel.add(iconWestLabel2, null);
        matrixNorthWestGridPanel.add(iconWestLabel3, null);
        matrixNorthWestGridPanel.add(iconWestLabel4, null);
        matrixNorthWestGridPanel.add(iconWestLabel5, null);
        matrixNorthWestGridPanel.add(iconWestLabel6, null);
        matrixNorthWestGridPanel.add(iconWestLabel7, null);
        matrixNorthWestGridPanel.add(iconWestLabel8, null);
        matrixNorthWestGridPanel.add(iconWestLabel9, null);

        matrixNorthEastGridPanel.setLayout(gridLayout2);
        gridLayout2.setColumns(3);
        gridLayout2.setRows(3);

        if(onlyTwo) { // onlyTwo = false (onlyTwo will be cleared when GizeTimerTask runs.)
            String[] a = dividing(secondLine);
            iconCenterLabel1 = new JLabel( icon_of_cell_1(a) );
            iconCenterLabel2 = new JLabel( icon_of_cell_2(a) );
            iconCenterLabel3 = new JLabel( icon_of_cell_3(a) );
            iconCenterLabel4 = new JLabel( icon_of_cell_4(a) );
            iconCenterLabel5 = new JLabel(icon41);
            iconCenterLabel6 = new JLabel( icon_of_cell_6(a) );
            iconCenterLabel7 = new JLabel( icon_of_cell_7(a) );
            iconCenterLabel8 = new JLabel( icon_of_cell_8(a) );
            iconCenterLabel9 = new JLabel( icon_of_cell_9(a) );
            matrixNorthEastGridPanel.add(iconCenterLabel1, null);
            matrixNorthEastGridPanel.add(iconCenterLabel2, null);
            matrixNorthEastGridPanel.add(iconCenterLabel3, null);
            matrixNorthEastGridPanel.add(iconCenterLabel4, null);
            matrixNorthEastGridPanel.add(iconCenterLabel5, null);
            matrixNorthEastGridPanel.add(iconCenterLabel6, null);
            matrixNorthEastGridPanel.add(iconCenterLabel7, null);
            matrixNorthEastGridPanel.add(iconCenterLabel8, null);
            matrixNorthEastGridPanel.add(iconCenterLabel9, null);
        } else {
            iconCenterLabel1 = new JLabel(icon41);
            iconCenterLabel2 = new JLabel(icon41);
            iconCenterLabel3 = new JLabel(icon41);
            iconCenterLabel4 = new JLabel(icon41);
            iconCenterLabel5 = new JLabel(icon41);
            iconCenterLabel6 = new JLabel(icon41);
            iconCenterLabel7 = new JLabel(icon41);
            iconCenterLabel8 = new JLabel(icon41);
            iconCenterLabel9 = new JLabel(icon41);
            matrixNorthEastGridPanel.add(iconCenterLabel1, null);
            matrixNorthEastGridPanel.add(iconCenterLabel2, null);
            matrixNorthEastGridPanel.add(iconCenterLabel3, null);
            matrixNorthEastGridPanel.add(iconCenterLabel4, null);
            matrixNorthEastGridPanel.add(iconCenterLabel5, null);
            matrixNorthEastGridPanel.add(iconCenterLabel6, null);
            matrixNorthEastGridPanel.add(iconCenterLabel7, null);
            matrixNorthEastGridPanel.add(iconCenterLabel8, null);
            matrixNorthEastGridPanel.add(iconCenterLabel9, null);
        }

        tripletNorthLabel.setFont(new java.awt.Font("Dialog", 0, 16));
        if( HYPHEN.equals(tripletNorthLabelText) ) {
            tripletNorthLabel.setForeground(SystemColor.inactiveCaptionText);
            tripletNorthLabel.setText(" ");
        } else {
            tripletNorthLabel.setForeground(SystemColor.controlText);
            tripletNorthLabel.setText(tripletNorthLabelText);
        }
        countComboBox.setFont(new java.awt.Font("SansSerif", 0, 16));
        countComboBox.setMaximumRowCount(OPTIONAL_TEXT_LINE_COUNT);

        countComboBox.addItem(COUNT_ONE);
        countComboBox.addItem(COUNT_TWO);
        countComboBox.addItem(COUNT_THREE);
        countComboBox.addItem(COUNT_FOUR);
        countComboBox.addItem(COUNT_FIVE);
        countComboBox.addItem(COUNT_SIX);
        countComboBox.addItem("---------------------------------------------------------------------"); // 69 hyphens
        countComboBox.addItem(COUNT_EIGHT);
/*
        countComboBox.addItem( makeObj(COUNT_ONE) );
        countComboBox.addItem( makeObj(COUNT_TWO) );
        countComboBox.addItem( makeObj(COUNT_THREE) );
        countComboBox.addItem( makeObj(COUNT_FOUR) );
        countComboBox.addItem( makeObj(COUNT_FIVE) );
        countComboBox.addItem( makeObj(COUNT_SIX) );
        countComboBox.addItem( makeObj("---------------------------------------------------------------------") ); // 69 hyphens
        countComboBox.addItem( makeObj(COUNT_EIGHT) );
*/
        itemCount = countComboBox.getItemCount();
        countComboBox.setSelectedIndex( LINES - 1 );
        countComboBox.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                countComboBox_keyPressed(e);
            }
        });
        countButton.setFont(new java.awt.Font("Dialog", 0, 16));
        countButton.setText("Count");
        countButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                countButton_actionPerformed(e);
            }
        });
        whoTextLine1 = drawLine();
        matrixCenterLabel.setForeground(SystemColor.inactiveCaptionText);
        matrixCenterLabel.setText(" ");
        matrixEastLabel.setForeground(SystemColor.inactiveCaptionText);
        matrixEastLabel.setText(" ");
        matrixNorthNorthLabel.setText(whoTextLine1);
        eastTextField(whoTextLine1);
        tripletSouthTextArea.setFont(new java.awt.Font("Dialog", 0, 16));
        tripletSouthTextArea.setText(">>");

        jTabbedPane1.add(tripletTabPanel, "Triplet");
        tripletTabPanel.add(tripletNorthPanel, BorderLayout.NORTH);
        tripletNorthPanel.add(tripletNorthLabel, BorderLayout.NORTH);
        tripletNorthPanel.add(countComboBox, BorderLayout.WEST);
        tripletNorthPanel.add(countButton, BorderLayout.CENTER);
        tripletNorthPanel.add(tripletEastTextField, BorderLayout.EAST);
        tripletNorthPanel.add(tripletSouthTextArea, BorderLayout.SOUTH);

        jTabbedPane1.add(matrixTabPanel, "Matrix");
        matrixTabPanel.add(matrixNorthPanel, BorderLayout.NORTH);
        matrixNorthPanel.add(matrixNorthNorthLabel, BorderLayout.NORTH);
        matrixNorthPanel.add(matrixNorthWestGridPanel, BorderLayout.WEST);
        matrixNorthPanel.add(matrixNorthCenterLabel, BorderLayout.CENTER);
        matrixNorthPanel.add(matrixNorthEastGridPanel, BorderLayout.EAST);
        matrixNorthPanel.add(matrixNorthSouthLabel, BorderLayout.SOUTH);

        matrixTabPanel.add(matrixCenterLabel, BorderLayout.CENTER);
        matrixTabPanel.add(matrixEastLabel, BorderLayout.EAST);
        matrixTabPanel.add(matrixSouthFlowPanel, BorderLayout.SOUTH);
        matrixTabPanel.add(matrixWestFlowPanel, BorderLayout.WEST);

        jTabbedPane1.add(jScrollPane1, "CSV");
        tableModel1 = new DefaultTableModel(COLUMN_NAMES, 0);
        JTable jTable1 = new JTable(tableModel1);
        jScrollPane1.getViewport().add(jTable1, null);

        int row_count = table.length;
        if(row_count > ROW_COUNT) {
            row_count = ROW_COUNT;
        }

        for(int i = 0; i < row_count; ++i) {
            tableModel1.addRow( septet(table[i]) );
        }

// Selecting MATRIX_TAB if necessary
        if(onlyTwo) { // onlyTwo = false (onlyTwo will be cleared when GizeTimerTask runs.)
            jTabbedPane1.setSelectedIndex(MATRIX_TAB);
        }

        tabSelected = jTabbedPane1.getSelectedIndex();
        gm = new GizeMask(this, LINES, false, false, true, false);
        task = new GizeTimerTask(this, gm, onlyTwo);
        timer = new java.util.Timer();
        timer.schedule(task, 0, NON_SAMPLING_PERIOD);
    }

    private void narrowHeader() {
        narrowPane = true;

        if(matrixNorthCenterLabel != null) {
            matrixNorthPanel.remove(matrixNorthCenterLabel);
            matrixNorthCenterLabel = null;
        }

        removeFromPanel();
        widePane = false;
        main_width = NARROW_PANE;
        if(shortPane) {
            main_height = SHORT_PANE;
        } else {
            main_height = MAIN_HEIGHT;
        }

        this.setSize( new Dimension(main_width, main_height) );
        GraphicsConfiguration gc = this.getGraphicsConfiguration();
        Rectangle bounds = gc.getBounds();

        switch(whichCorner) {
        case 1:
            main_x = 0;
            main_y = 0;
            break;
        case 2:
            main_x = bounds.width - main_width;
            main_y = 0;
            break;
        case 3:
            main_x = bounds.width - main_width;
            main_y = bounds.height - main_height - TASK_BAR_HEIGHT;
            break;
        case 4:
            main_x = 0;
            main_y = bounds.height - main_height - TASK_BAR_HEIGHT;
            break;
        default:
            main_x = bounds.width/2 - main_width/2;
            main_y = bounds.height/2 - main_height/2;
            break;
        }

        this.setLocation( bounds.x + main_x, bounds.y + main_y );
        repainting();
    }

    private void repainting() {
        invalidate();
        validate();
        repaint();
    }

    private void rightHandler() {
        whichCorner = 2;

        GraphicsConfiguration gc = this.getGraphicsConfiguration();
        Rectangle bounds = gc.getBounds();
        main_height = this.getHeight();
        main_width = this.getWidth();

        main_x = bounds.width - main_width;
        main_y = 0;
        this.setLocation( bounds.x + main_x, bounds.y + main_y );
    }

    private void standardHeader(boolean perfect) {
        if(matrixNorthCenterLabel == null) {
            matrixNorthCenterLabel = new JLabel(icon_of_numbered_cells);
            matrixNorthPanel.add(matrixNorthCenterLabel, BorderLayout.CENTER);
        }

        if(perfect) {
            whichCorner = 0;
            main_x = standard_main_x;
            main_y = standard_main_y;
            narrowPane = false;
            shortPane = false;
            widePane = false;
        }

        if(widePane) {
            main_width = WIDE_PANE;
        } else {
            main_width = MAIN_WIDTH;
        }

        if(shortPane) {
            main_height = SHORT_PANE;
        } else {
            main_height = MAIN_HEIGHT;
        }

        this.setSize( new Dimension(main_width, main_height) );
        GraphicsConfiguration gc = this.getGraphicsConfiguration();
        Rectangle bounds = gc.getBounds();

        switch(whichCorner) {
        case 1:
            main_x = 0;
            main_y = 0;
            break;
        case 2:
            main_x = bounds.width - main_width;
            main_y = 0;
            break;
        case 3:
            main_x = bounds.width - main_width;
            main_y = bounds.height - main_height - TASK_BAR_HEIGHT;
            break;
        case 4:
            main_x = 0;
            main_y = bounds.height - main_height - TASK_BAR_HEIGHT;
            break;
        default:
            main_x = bounds.width/2 - main_width/2;
            main_y = bounds.height/2 - main_height/2;
            break;
        }

        this.setLocation( bounds.x + main_x, bounds.y + main_y );

        if(perfect) {
            standard_main_x = main_x;
            standard_main_y = main_y;
        }

        repainting();
    }

    private void stringArrayToValues() {
        fileName = m[1];
        list_of_items = m[2];
        lines = stringToInteger(m[3]);
        cell_5 = ( FALSE.equals(m[4]) ) ? false : true;
        firstLine = ( FALSE.equals(m[5]) ) ? false : true;
        noSplitting = ( FALSE.equals(m[6]) ) ? false : true;
        preedit = ( FALSE.equals(m[7]) ) ? false : true;
        rowCount = stringToInteger(m[8]);
        serialNumber = ( FALSE.equals(m[9]) ) ? false : true;
        ticketForm = ( FALSE.equals(m[10]) ) ? false : true;
        whoText = ( FALSE.equals(m[11]) ) ? false : true;
        toGize = ( FALSE.equals(m[12]) ) ? false : true;
        whichCorner = stringToInteger(m[13]);
    }

    private void underHandler() {
        whichCorner = 4;

        GraphicsConfiguration gc = this.getGraphicsConfiguration();
        Rectangle bounds = gc.getBounds();
        main_height = this.getHeight();
        main_width = this.getWidth();

        main_x = 0;
        main_y = bounds.height - main_height - TASK_BAR_HEIGHT;
        this.setLocation( bounds.x + main_x, bounds.y + main_y );
    }

    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if( e.getID() == WindowEvent.WINDOW_CLOSING ) {
            jMenuFileExit_actionPerformed(null);
        }
    }

    public boolean setting(String f, String fi, String l, int li, boolean c, boolean fir, boolean n, boolean p, boolean s, boolean t, boolean w) {
        FULL_PATH_NAME = f;
        readManageText();

        fileName = fi;
        list_of_items = l;
        lines = li;
        cell_5 = c;
        csv = false;
        firstLine = fir;
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();
        DOUBLE_SPACE = NEW_LINE + NEW_LINE;
        noSplitting = n;
        preedit = p;
        quit = false;
        serialNumber = s;
        ticketForm = t;
        whoText = w;

        testDrafoCsv();

        if(lines < 1 || 8 < lines) {
            lines = LINES;
        }

        countComboBox.setSelectedIndex( lines - 1 );
        gm = new GizeMask(this, lines, cell_5, noSplitting, serialNumber, whoText);

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(list_of_items) );
            buffered.close();
            return true;
        } catch(IOException e33) {
            error = "IOException e33: " + list_of_items;
            createErrorText(error);

            if( EXCLUDE_TEXT.equals(list_of_items) ) {
                createExcludeText();
            }

            list_of_items = EXCLUDE_TEXT;
            return false;
        }

    }

    public GizeFrame(String[] t, String[] d, String n, String s, String w, double v, int wh, boolean on) {
        draw = d;
        error = NO_ERROR;
        name_of_CSV = n;
        onlyTwo = on;
        optional = new String[OPTIONAL_TEXT_LINE_COUNT];
        table = t;
        secondLine = s;
        versionNumber = v;
        whichCorner = wh;
        whoTextLine1 = w;

        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try {
            jbInit();
        } catch(Exception e30) {
            error = "Exception e30";
        }

    }

    public void addToPanel() {
        for(int i = 0; i < imageCount; ++i) {
            if(i >= 5) { // 5, 6, 7
                matrixSouthFlowCenterLabel[i] = new JLabel(flowLine[i]);
                matrixSouthFlowPanel.add(matrixSouthFlowCenterLabel[i], null);
            } else { // 0, 1, 2, 3, 4
                matrixWestFlowCenterLabel[i] = new JLabel(flowLine[i]);
                matrixWestFlowPanel.add(matrixWestFlowCenterLabel[i], null);
            }

        }

    }

    public void comparing(GizeMask gm) {
        String[] a = gm.twoMatrices(secondLine, whoTextLine1);
        gm.illustrateUnbrokenLines();

        matrixNorthEastGridPanel.remove(iconCenterLabel1);
        matrixNorthEastGridPanel.remove(iconCenterLabel2);
        matrixNorthEastGridPanel.remove(iconCenterLabel3);
        matrixNorthEastGridPanel.remove(iconCenterLabel4);
        matrixNorthEastGridPanel.remove(iconCenterLabel5);
        matrixNorthEastGridPanel.remove(iconCenterLabel6);
        matrixNorthEastGridPanel.remove(iconCenterLabel7);
        matrixNorthEastGridPanel.remove(iconCenterLabel8);
        matrixNorthEastGridPanel.remove(iconCenterLabel9);

        iconCenterLabel1 = new JLabel( icon_of_cell_1(a) );
        iconCenterLabel2 = new JLabel( icon_of_cell_2(a) );
        iconCenterLabel3 = new JLabel( icon_of_cell_3(a) );
        iconCenterLabel4 = new JLabel( icon_of_cell_4(a) );
        iconCenterLabel5 = new JLabel(icon41);
        iconCenterLabel6 = new JLabel( icon_of_cell_6(a) );
        iconCenterLabel7 = new JLabel( icon_of_cell_7(a) );
        iconCenterLabel8 = new JLabel( icon_of_cell_8(a) );
        iconCenterLabel9 = new JLabel( icon_of_cell_9(a) );
        matrixNorthEastGridPanel.add(iconCenterLabel1, null);
        matrixNorthEastGridPanel.add(iconCenterLabel2, null);
        matrixNorthEastGridPanel.add(iconCenterLabel3, null);
        matrixNorthEastGridPanel.add(iconCenterLabel4, null);
        matrixNorthEastGridPanel.add(iconCenterLabel5, null);
        matrixNorthEastGridPanel.add(iconCenterLabel6, null);
        matrixNorthEastGridPanel.add(iconCenterLabel7, null);
        matrixNorthEastGridPanel.add(iconCenterLabel8, null);
        matrixNorthEastGridPanel.add(iconCenterLabel9, null);

        jTabbedPane1.setSelectedIndex(MATRIX_TAB);
    }

    public void counting() {
        countComboBox.setSelectedIndex( lines - 1 );
        editCountLines();
    }

    public void displaying(String s) {
        tripletSouthTextArea.setText(s);
        jTabbedPane1.setSelectedIndex(TRIPLET_TAB);
    }

    public void eastTextField(String s) {
        tripletEastTextField.setFont(new java.awt.Font("SansSerif", 0, 16));
        if( MANY_HYPHENS.equals(s) ) {
            tripletEastTextField.setForeground(SystemColor.text);
            tripletEastTextField.setText(MANY_HYPHENS);
        } else {
            tripletEastTextField.setForeground(SystemColor.textText);
            tripletEastTextField.setText(s);
        }

    }

    public void if_written_file_shall_be_read_again() {
       if( readManageText() ) {
           statusBarMessage(FULL_PATH_NAME);
       } else {
           error = "if_written_file_shall_be_read_again(): readManageText()";
           createErrorText(error);
           System.exit(ERROR_CODE);
       }

    }

    public void jMenuFileAwakening_actionPerformed(ActionEvent e) {
        createAnnuyText();
        String newLine1 = selectingAsDraw(FROM);
        if( EMPTY.equals(newLine1) ) {
            createErrorText(error);
        } else {
            String name = segmentalize(newLine1);
            if( EMPTY.equals(name) ) {
                createErrorText(error);
            } else {
                String s = header(name);
                displaying(s);
            }

        }

    }

    public void jMenuFileClean_actionPerformed(ActionEvent e) {
        try {
            Runtime rt = Runtime.getRuntime();
            rt.exec(RVOY);
            statusBarMessage(REMOVE_ERROR_TEXT);
        } catch (SecurityException e28) {
            statusBarMessage("SecurityException e28");
        } catch (IOException e32) {
            statusBarMessage("IOException e32");
        }

    }

    public void jMenuFileCountEightLines_actionPerformed(ActionEvent e) {
        lines = 8;
        countComboBox.setSelectedIndex( lines - 1 );
        editCountLines();
    }

    public void jMenuFileCountFiveLines_actionPerformed(ActionEvent e) {
        lines = 5;
        countComboBox.setSelectedIndex( lines - 1 );
        editCountLines();
    }

    public void jMenuFileCountFourLines_actionPerformed(ActionEvent e) {
        lines = 4;
        countComboBox.setSelectedIndex( lines - 1 );
        editCountLines();
    }

    public void jMenuFileCountOneLine_actionPerformed(ActionEvent e) {
        lines = 1;
        countComboBox.setSelectedIndex( lines - 1 );
        editCountLines();
    }

    public void jMenuFileCountSixLines_actionPerformed(ActionEvent e) {
        lines = 6;
        countComboBox.setSelectedIndex( lines - 1 );
        editCountLines();
    }

    public void jMenuFileCountThreeLines_actionPerformed(ActionEvent e) {
        lines = 3;
        countComboBox.setSelectedIndex( lines - 1 );
        editCountLines();
    }

    public void jMenuFileCountTwoLines_actionPerformed(ActionEvent e) {
        lines = 2;
        countComboBox.setSelectedIndex( lines - 1 );
        editCountLines();
    }

    public void jMenuFileCSV_actionPerformed(ActionEvent e) {
        CSVdialog();
    }

    public void jMenuFileExit_actionPerformed(ActionEvent e) {
        System.exit(0);
    }

    public void jMenuFileManage_actionPerformed(ActionEvent e) {
        GizeFrame_ManageBox dlg = new GizeFrame_ManageBox(this);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation( loc.x + frmSize.width/2 - dlgSize.width/2, loc.y + frmSize.height/2 - dlgSize.height/2 );
        dlg.setting(FULL_PATH_NAME, cell_5, noSplitting, preedit, ticketForm, whoText);
        dlg.setModal(true);
        dlg.pack();
        dlg.setVisible(true);
    }

    public void jMenuFileMatrix_actionPerformed(ActionEvent e) {
        secondLine = tripletEastTextField.getText();
        comparing(gm);
    }

    public void jMenuFileOptional_actionPerformed(ActionEvent e) {
        optionalAdding();
    }

    public void jMenuFilePreedit_actionPerformed(ActionEvent e) {
        preediting();
    }

    public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
        GizeFrame_AboutBox dlg = new GizeFrame_AboutBox(this);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation( loc.x + frmSize.width/2 - dlgSize.width/2, loc.y + frmSize.height/2 - dlgSize.height/2 );
        dlg.setVersion( String.valueOf(versionNumber) );
        dlg.setModal(true);
        dlg.pack();
        dlg.setVisible(true);
    }

    public void jMenuWindowCenter_actionPerformed(ActionEvent e) {
        centering();
    }

    public void jMenuWindowCorner_actionPerformed(ActionEvent e) {
        cornerHandler();
    }

    public void jMenuWindowCSV_actionPerformed(ActionEvent e) {
        jTabbedPane1.setSelectedIndex(CSV_TAB);
    }

    public void jMenuWindowDiagonal_actionPerformed(ActionEvent e) {
        diagonalHandler();
    }

    public void jMenuWindowHeight_actionPerformed(ActionEvent e) {
        GraphicsConfiguration gc = this.getGraphicsConfiguration();
        Rectangle bounds = gc.getBounds();

        if(shortPane) {
            shortPane = false;
            main_height = MAIN_HEIGHT;
            int y = bounds.height - STATUS_BAR_HEIGHT - MAIN_HEIGHT;
            if(y < main_y) {
                 main_y = y;
            }

        } else {
            shortPane = true;
            main_height = SHORT_PANE;
        }

        main_width = this.getWidth();
        this.setSize( new Dimension(main_width, main_height) );
        this.setLocation( bounds.x + main_x, bounds.y + main_y );
        repainting();
    }

    public void jMenuWindowMinimize_actionPerformed(ActionEvent e) {
        this.setState(Frame.ICONIFIED);
    }

    public void jMenuWindowNarrow_actionPerformed(ActionEvent e) {
        narrowHeader();
    }

    public void jMenuWindowRight_actionPerformed(ActionEvent e) {
        rightHandler();
    }

    public void jMenuWindowSmall_actionPerformed(ActionEvent e) {
        shortPane = true;
        narrowHeader();
    }

    public void jMenuWindowStandard_actionPerformed(ActionEvent e) {
        standardHeader(PERFECT);
    }

    public void jMenuWindowUnder_actionPerformed(ActionEvent e) {
        underHandler();
    }

    public void jMenuWindowWidth_actionPerformed(ActionEvent e) {
        GraphicsConfiguration gc = this.getGraphicsConfiguration();
        Rectangle bounds = gc.getBounds();

        if(widePane) {
            widePane = false;
            if(narrowPane) {
                main_width = NARROW_PANE;
            } else {
                main_width = MAIN_WIDTH;
            }

        } else {
            widePane = true;
            main_width = WIDE_PANE;
            int x = bounds.width - WIDE_PANE;
            if(x < main_x) {
                 main_x = x;
            }

        }

        main_height = this.getHeight();
        this.setSize( new Dimension(main_width, main_height) );
        this.setLocation( bounds.x + main_x, bounds.y + main_y );
        repainting();
    }

    public void northLabel(String s) {
        if( s.length() > 0 ) {
            matrixNorthNorthLabel.setForeground(SystemColor.windowText);
            matrixNorthNorthLabel.setText(s);
        } else {
            matrixNorthNorthLabel.setForeground(SystemColor.inactiveCaptionText);
            matrixNorthNorthLabel.setText(" ");
        }

    }

    public void removeFromPanel() {
        for(int i = 0; i < MASK_COUNT; ++i) {
            if(matrixSouthFlowCenterLabel[i] != null) {
                matrixSouthFlowPanel.remove(matrixSouthFlowCenterLabel[i]);
                matrixSouthFlowCenterLabel[i] = null;
            }

            if(matrixWestFlowCenterLabel[i] != null) {
                matrixWestFlowPanel.remove(matrixWestFlowCenterLabel[i]);
                matrixWestFlowCenterLabel[i] = null;
            }

            flowLine[i] = null;
        }

        imageCount = 0;
    }

    public void selectImage(UnbrokenLine ul) {
        int mask_index = ul.index(imageCount);
        flowLine[imageCount] = imageList[mask_index];
        imageCount += 1; // imageCount < MASK_COUNT
    }

    public void similarLine(GizeMask gm) {
        StringBuffer os = new StringBuffer();
        os.append(draw[1]);
        os.append(GAP);
        os.append(draw[2]);
        os.append(GAP);
        os.append(draw[3]);
        os.append(GAP_SLASH);
        os.append(draw[4]);
        os.append(GAP);
        os.append( similarBall(draw[6]) );
        os.append(GAP_SLASH);
        os.append( similarBall(draw[7]) );
        os.append(GAP);
        os.append(draw[8]);
        os.append(GAP);
        os.append(draw[9]);
        os.append(GAP_SLASH_SLASH);
        secondLine = os.toString();
        comparing(gm);
    }

    public void statusBarMessage(String s) {
        statusBar.setText(s);
        statusBarText = s;
    }

    void countButton_actionPerformed(ActionEvent e) {
        Object o = countComboBox.getSelectedItem();
        String s = o.toString();

        if( COUNT_ONE.equals(s) ) {
            lines = 1;
        } else if( COUNT_TWO.equals(s) ) {
            lines = 2;
        } else if( COUNT_THREE.equals(s) ) {
            lines = 3;
        } else if( COUNT_FOUR.equals(s) ) {
            lines = 4;
        } else if( COUNT_FIVE.equals(s) ) {
            lines = 5;
        } else if( COUNT_SIX.equals(s) ) {
            lines = 6;
        } else if( COUNT_EIGHT.equals(s) ) {
            lines = 8;
        } else {
            int place = whichCorner;

            Optional p = new Optional(FULL_PATH_NAME);
            OptionalCode oc = p.command(s);
            cell_5 = oc.codeCell5();
            csv = oc.codeCsv();
            fileName = oc.codeFile();
            firstLine = oc.codeLine1();
            FULL_PATH_NAME = oc.codePath();
            lines = oc.codeLines();
            list_of_items = oc.codeList();
            noSplitting = oc.codeDate();
            preedit = oc.codeEdit();
            quit = oc.codeQuit();
            rowCount = oc.codeRows();
            serialNumber = oc.codeSerial();
            ticketForm = oc.codeTicket();
            whichCorner = oc.codeCorner();
            whoText = oc.codeOverwrite();

            if(whichCorner != place) {
                standardHeader(IMPERFECT);
            }

            if(csv) {
                CSVdialog();
                csv = false;
                return;
            }

            if(quit) {
                preediting();
                quit = false;
                return;
            }

        }

        editCountLines();
    }

    void countComboBox_keyPressed(KeyEvent e) {
        int keyCode = e.getKeyCode();
        if(keyCode == e.VK_F7) {
            secondLine = tripletEastTextField.getText();
            comparing(gm);
        } else if(keyCode == e.VK_F12) {
            displaying(statusBarText);
        } else if(keyCode == e.VK_SPACE) {
            optionalAdding();
        }

    }

    void jScrollPane1_mouseMoved(MouseEvent e) {
    }

    void jTabbedPane1_mouseClicked(MouseEvent e) {
        tabSelected = jTabbedPane1.getSelectedIndex();
    }

    void statusBar_mouseClicked(MouseEvent e) {
        displaying(statusBarText);
    }

    void this_mouseMoved(MouseEvent e) {
    }

}
