package info.lotosummary.software;

import java.util.*;

public class RandomNumber {
    static final boolean NOT_CSV = false;
    static final double N_2_31 = 2147483648.0; // 2^31 = 2147483648
    static final int ALL = 40;
    static final int ANNUY_ARRAY_SIZE = ALL + 1;
    static final int A_TRIPLET_IN_EACH_LINE = 1;
    static final int CELL_COUNT = 9;
    static final int CELL_COUNT_1 = CELL_COUNT - 1;
    static final int KEY_LENGTH = 4;
    static final int LARGE_NUMBER = 2147483647;
    static final int MERSENNE_TWISTER = 1;
    static final int NOT_CONVERTED = -1;
    static final int XORSHIFT = 6;
    static final long KB = 1024L;
    static final long KILOBYTES = 32L;
    static final long TEN_DIGITS = 1000000000L;
    static final String ANNUY_TEXT = "annuy.txt";
    static final String CELL_5 = "** ";
    static final String GAP = " ";
    static final String LINE_1_2_3 = "/";
    static final String LINE_4_6 = "/";
    static final String LINE_7_8_9 = "//";
    static final String NO_ERROR = "No error";
    static final String[] b = {"00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", "54", "55", "56", "57", "58", "59", "60", "61", "62", "63", "64", "65", "66", "67", "68", "69", "70", "71", "72", "73", "74", "75", "76", "77", "78", "79", "80", "81", "82", "83", "84", "85", "86", "87", "88", "89", "90", "91", "92", "93", "94", "95", "96", "97", "98", "99"};

    boolean cell_5, produce_annuy_text;
    int from, lineCount, prng;
    long kilo, seed;
    PRNG prn;
    String error;

    private String[] driveDirectoryBase(String s) {
        String SLASH = "/";
        String YEN = "\\";
        String[] UNDIVIDED = {"", "", "", "", ""};
        int firstTrace, trace, w;
        int s_length = s.length();
        String c;
        String SEPARATOR = YEN;
        String[] part = {"", "", "", "", ""};
        part[0] = s; // s.length > 0; in other words, part[0].length > UNDIVIDED[0].length

// s is divided into three parts: drive name, directory name, and base name.
        int k = 0;
        for( ; k < s_length; ++k) {
            c = s.substring(k, k + 1 );
            if( YEN.equals(c) ) {
                SEPARATOR = YEN;
                break;
            } else if( SLASH.equals(c) ) {
                SEPARATOR = SLASH;
                break;
            }

        }

        if(k == s_length) { // Neither YEN nor SLASH has been found.
            return UNDIVIDED;
        } else {
            w = k + 1;
            part[1] = s.substring(0, w); // C:\ for example
            trace = ++k;
            firstTrace = trace;
        }

        for( ; k < s_length; ++k) {
            c = s.substring(k, k + 1 );
            if( SEPARATOR.equals(c) ) {
                trace = ++k;
            }

        }

        part[2] = s.substring(firstTrace, trace);
        part[3] = s.substring(trace); // manage.txt for example
        part[4] = SEPARATOR;
        return part;
    }

    public int random_integer() {
        return prn.nextRandom();
    }

    public void setPRNG() {

        switch (prng) {
        case MERSENNE_TWISTER:
            prn = new MT(seed);
            break;
        case XORSHIFT:
//            prn = new Xorshift(seed);
            break;
        default:
            break;
        }

// idling
        for(int k = 0; k < from; ++k) { 
            random_integer();
        }

    }

    public boolean createAnnuyText(String pathName) {
        String[] name = {"", "", "", "", ""};
        name = driveDirectoryBase(pathName);
        String directoryName = name[1] + name[2]; // C:\AnnuyJava\ for example

// Redirecting unless ANNUY_TEXT is opened.
        pathName = directoryName + ANNUY_TEXT;
        Feedable f = new FileOutputNewLineCount(pathName, lineCount);
        f.setting(GAP, A_TRIPLET_IN_EACH_LINE, cell_5);

        if(seed == 0L) {
            Calendar now = Calendar.getInstance();
            int year = now.get(Calendar.YEAR);
            int month = now.get(Calendar.MONTH);
            int day = now.get(Calendar.DATE);
            int hour = now.get(Calendar.HOUR);
            int minute = now.get(Calendar.MINUTE);
            int second = now.get(Calendar.SECOND);
            int add = minute * 60 + hour * 60 * 60;
            int year_month_day_43 = (year + month + day) * 43;
            second += add;
            second += year_month_day_43;
            seed = (long)second;
        }

        setPRNG(); // from, seed

// Selecting an item and writing
        BallCellData b = new BallCellData();
        AnnuyCode[] a = b.AnnuySetting();
        boolean[] marked = {false, false, false, false, false, true, false, false, false, false}; // marked.length = CELL_COUNT + 1
        boolean[] selected = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false}; // selected.length = ANNUY_ARRAY_SIZE
        double g;
        double difference, range;
        int interval_0 = 1;
        int interval_1 = 40;
        int itemCount;
        int k, plus;
        long bytes;
        long size = 0L;
        String item;
        StringBuffer os;

        bytes = kilo * KB;
        difference = (double)( interval_1 - interval_0 + 1 );
        range = difference/4294967296.0;
        while(size <= bytes) {
// Marking CELL_COUNT_1 times
            for(int u = 0; u < CELL_COUNT_1; ++u) {
                do {
                    g = (double)prn.nextRandom();
                    g += N_2_31; // 0 to 4294967295
                    plus = (int)Math.floor( range * g );
                    k = interval_0 + plus;
                } while(marked[ a[k].cell ]);

                marked[ a[k].cell ] = true;
                selected[ a[k].ball ] = true;
            }

// Sorting
            itemCount = 0;
            os = new StringBuffer();
            for(int r = 1; r <= ALL; ++r) { // ANNUY_ARRAY_SIZE = ALL + 1
                if(selected[r]) {
                    os.append(a[r].data);
                    os.append(GAP);
                    selected[r] = false;
                    marked[ a[r].cell ] = false;

                    itemCount += 1;
                    switch(itemCount) {
                    case 3:
                        os.append(LINE_1_2_3);
                        break;
                    case 4:
                        if(cell_5) {
                            os.append(CELL_5);
                        }

                        break;
                    case 5:
                        os.append(LINE_4_6);
                        break;
                    case 8:
                        os.append(LINE_7_8_9);
                        break;
                    default:
                        break;
                    }

                }

            }

            item = os.toString();
            size = f.writing(item);
        }

        f.ending(NOT_CSV);
        return true;
    }

    public RandomNumber(long k, long s, int f, int l, int p, boolean c, boolean pr) {
        cell_5 = c;
        error = NO_ERROR;
        from = f;
        lineCount = l;
        prng = p;
        produce_annuy_text = pr;
        kilo = k;
        seed = s;
    }

}
